{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
osCommerce Product Manager for Windows (oscpmwin).
Copyright 2003,2004,2005 by Mario A. Valdez-Ramirez.

You can contact Mario A. Valdez-Ramirez
by email at mario@mariovaldez.org or paper mail at
Olmos 809, San Nicolas, NL. 66495, Mexico.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or (at
your option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
unit currupd;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ComCtrls, modules, Menus;

type
  Topm_Form_Currupd = class(TForm)
    opm_ListView_CurrUpdConfirm: TListView;
    opm_BitBtn_CurrUpdConfirm: TBitBtn;
    opm_BitBtn_CurrUpdCancel: TBitBtn;
    opm_StatusBar_PEdit: TStatusBar;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
  public
  end;

var
  opm_Form_Currupd : Topm_Form_Currupd;



implementation

Uses gnugettext, main, oscpmdata, balloons, dataman, clipbrd, network;

{$R *.dfm}







{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Currupd.FormShow (Sender: TObject);
VAR
  CurCurr : LONGINT;
  CurItem : TListItem;
BEGIN
  opm_Form_Currupd.Caption := _('Currency update confirmation');
  opm_ListView_CurrUpdConfirm.Items.BeginUpdate;
  opm_ListView_CurrUpdConfirm.Items.Clear;
  FOR CurCurr := 0 TO (opm_TotalCurrencies - 1) DO
    BEGIN
      IF (opmG_CurrencyList[CurCurr].Default = FALSE) THEN
        BEGIN
          CurItem := opm_ListView_CurrUpdConfirm.Items.Add;
          IF (opmG_CurrencyList[CurCurr].NewValue = 0) THEN CurItem.ImageIndex := 2
          ELSE IF (opmG_CurrencyList[CurCurr].NewValue = -1) THEN CurItem.ImageIndex := 1
          ELSE IF (opmG_CurrencyList[CurCurr].Value = opmG_CurrencyList[CurCurr].NewValue) THEN CurItem.ImageIndex := 3
          ELSE CurItem.ImageIndex := 4;
          CurItem.SubItems.Add (opmG_CurrencyList[CurCurr].Name);
          CurItem.SubItems.Add (CURRTOSTR (opmG_CurrencyList[CurCurr].Value));
          IF (opmG_CurrencyList[CurCurr].NewValue <= 0) THEN CurItem.SubItems.Add ('???')
          ELSE CurItem.SubItems.Add (CURRTOSTR (opmG_CurrencyList[CurCurr].NewValue));
        END;
    END;
  opm_ListView_CurrUpdConfirm.Items.EndUpdate;
END;




{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Currupd.FormCreate(Sender: TObject);
begin
  opm_ListView_CurrupdConfirm.Columns.Clear;
  opm_ListView_CurrupdConfirm.Checkboxes := FALSE;
  opm_ListView_CurrupdConfirm.ReadOnly := TRUE;
  opm_ListView_CurrupdConfirm.DoubleBuffered := TRUE;
  opm_ListView_CurrupdConfirm.ViewStyle := vsReport;
  opm_ListView_CurrupdConfirm.Columns.Add;
  opm_ListView_CurrupdConfirm.Columns.Add;
  opm_ListView_CurrupdConfirm.Columns.Add;
  opm_ListView_CurrupdConfirm.Columns.Add;
  opm_ListView_CurrupdConfirm.Columns.Items[0].Caption := '';
  opm_ListView_CurrupdConfirm.Columns.Items[1].Caption := _('Currency');
  opm_ListView_CurrupdConfirm.Columns.Items[2].Caption := _('Old value');
  opm_ListView_CurrupdConfirm.Columns.Items[3].Caption := _('New value');
  opm_ListView_CurrupdConfirm.Columns.Items[1].Alignment := opmC_Def_Col20Align;
  opm_ListView_CurrupdConfirm.Columns.Items[2].Alignment := opmC_Def_Col21Align;
  opm_ListView_CurrupdConfirm.Columns.Items[3].Alignment := opmC_Def_Col22Align;
  IF (opmG_UIHotTracking > 0) THEN
    BEGIN
      opm_ListView_CurrupdConfirm.HotTrack := FALSE;
      opm_ListView_CurrupdConfirm.HotTrackStyles := [htHandPoint, htUnderlineHot];
    END
  ELSE
    BEGIN
      opm_ListView_CurrupdConfirm.HotTrack := FALSE;
      opm_ListView_CurrupdConfirm.HotTrackStyles := [];
    END;
  IF (opmG_UIRememberDisplay > 0) THEN
    BEGIN
      opm_ListView_CurrupdConfirm.Column[0].Width := opmG_UICol0X;
      opm_ListView_CurrupdConfirm.Column[1].Width := opmG_UICol20X;
      opm_ListView_CurrupdConfirm.Column[2].Width := opmG_UICol21X;
      opm_ListView_CurrupdConfirm.Column[3].Width := opmG_UICol22X;
    END
  ELSE
    BEGIN
      opm_ListView_CurrupdConfirm.Column[0].Width := opmC_Def_Col0X;
      opm_ListView_CurrupdConfirm.Column[1].Width := opmC_Def_Col20X;
      opm_ListView_CurrupdConfirm.Column[2].Width := opmC_Def_Col21X;
      opm_ListView_CurrupdConfirm.Column[3].Width := opmC_Def_Col22X;
    END;
  TranslateComponent (self);
end;



end.
